function 拖动条颜色(id,颜色)
  id.ProgressDrawable.setColorFilter(PorterDuffColorFilter(颜色,PorterDuff.Mode.SRC_ATOP))
  id.Thumb.setColorFilter(PorterDuffColorFilter(颜色,PorterDuff.Mode.SRC_ATOP))
end

function Ripple(id,color,t)
  import "android.content.res.ColorStateList"
  local attrsArray = {android.R.attr.selectableItemBackgroundBorderless}
  local typedArray =activity.obtainStyledAttributes(attrsArray)
  circle=typedArray.getResourceId(0,0)
  square=activity.obtainStyledAttributes({android.R.attr.selectableItemBackground}).getResourceId(0,0)
  if t=="圆" then
    ripple=circle
   elseif t=="方" then
    ripple=square
   else
    ripple=circle
  end
  Pretend=activity.Resources.getDrawable(ripple)
  if id then
    id.setBackground(Pretend.setColor(ColorStateList(int[0].class{int{}},int{color})))
   else
    return Pretend.setColor(ColorStateList(int[0].class{int{}},int{color}))
  end
end
bowen=Ripple
波纹=Ripple

function DialogButtonFilter(id,button,颜色)
  if Build.VERSION.SDK_INT >= 22 then
    import "android.graphics.PorterDuffColorFilter"
    import "android.graphics.PorterDuff"
    if button==1 then
      id.getButton(id.BUTTON_POSITIVE).setTextColor(颜色)
     elseif button==2 then
      id.getButton(id.BUTTON_NEGATIVE).setTextColor(颜色)
     elseif button==3 then
      id.getButton(id.BUTTON_NEUTRAL).setTextColor(颜色)
    end
  end
end
对话框按钮颜色=DialogButtonFilter


function activity背景颜色(color)
  _window = activity.getWindow();
  _window.setBackgroundDrawable(ColorDrawable(color));
  _wlp = _window.getAttributes();
  _wlp.gravity = Gravity.BOTTOM;
  _wlp.width = WindowManager.LayoutParams.MATCH_PARENT;
  _wlp.height = WindowManager.LayoutParams.MATCH_PARENT;--WRAP_CONTENT
  _window.setAttributes(_wlp);
end

function 是否暗色(color)
  local r=utf8.sub(color,3,4)
  local g=utf8.sub(color,5,6)
  local b=utf8.sub(color,7,8)

  function toint(e)
    import 'java.lang.Long'
    return Long.parseLong(e, 16)
  end
  grayLevel = (toint(r) * 0.299) + (toint(g) * 0.587) + (toint(b) * 0.114)
  if (grayLevel <= 192) then
    return true
   else
    return false
  end

end
function 获取主题颜色()

  array = activity.getTheme().obtainStyledAttributes({
    android.R.attr.colorBackground,
    android.R.attr.textColorPrimary,
    android.R.attr.colorPrimary,
    android.R.attr.colorPrimaryDark,
    android.R.attr.colorAccent,
    android.R.attr.navigationBarColor,
    android.R.attr.statusBarColor,
    android.R.attr.colorButtonNormal,
  });

  colorBackground = array.getColor(0, 0xFF00FF)
  textColorPrimary = array.getColor(1, 0xFF00FF)
  colorPrimary = array.getColor(2, 0xFF00FF)
  colorPrimaryDark = array.getColor(3, 0xFF00FF)
  colorAccent = array.getColor(4, 0xFF00FF)
  navigationBarColor = array.getColor(5, 0xFF00FF)
  statusBarColor = array.getColor(6, 0xFF00FF)
  colorButtonNormal = array.getColor(7, 0xFF00FF)

  强调色=colorAccent
  工具栏颜色=colorPrimary
  导航栏颜色=navigationBarColor
  状态栏颜色=statusBarColor
end

function 修改颜色强度(强度,颜色)--16进制
  return (tonumber("0x"..强度..string.sub(Integer.toHexString(强调色),3,8)))
end


function 刷新主题()
  import "android.graphics.PorterDuffColorFilter"
  import "android.graphics.PorterDuff"
  import "android.graphics.Color"
  import "android.graphics.drawable.ColorDrawable"
  if activity.getSharedData("主题") == nil then
    activity.setSharedData("主题","1")
  end

  if activity.getSharedData("主题")=="1" then
    activity.setTheme(R.Theme_AppLua7)
    获取主题颜色()
    背景颜色=0xffffffff

    强调文字色=0xFFFFFFFF
    强调图片色=0xFFFFFFFF
    强调波纹=0x44FFFFFF
    淡色强调=修改颜色强度(22,强调色)
    淡色强调波纹=修改颜色强度(44,强调色)
    淡色普通=0xfff5f5f5
    淡色普通波纹=0x22000000
    普通色=0xFFFFFFFF
    普通文字色=0xFF000000
    普通图片色=0xFF4E5264
    普通波纹=0x22000000
    工具栏阴影=0
    云极客颜色="indigo"
    导航栏颜色=0xFF000000
  end
  if activity.getSharedData("主题")=="2" then
    activity.setTheme(R.Theme_AppLua)
    获取主题颜色()
    背景颜色=0xffffffff

    强调文字色=0xFFFFFFFF
    强调图片色=0xFFFFFFFF
    强调波纹=0x44FFFFFF
    淡色强调=修改颜色强度(22,强调色)
    淡色强调波纹=修改颜色强度(44,强调色)
    淡色普通=0xfff5f5f5
    淡色普通波纹=0x22000000
    普通色=0xFFFFFFFF
    普通文字色=0xFF000000
    普通图片色=0xFF4E5264
    普通波纹=0x44000000
    工具栏阴影=0
    云极客颜色="indigo"
  end
  if activity.getSharedData("主题")=="3" then
    activity.setTheme(R.Theme_AppLua2)
    获取主题颜色()
    背景颜色=0xffffffff

    强调文字色=0xFFFFFFFF
    强调图片色=0xFFFFFFFF
    强调波纹=0x99EFDC75
    淡色强调=修改颜色强度(22,强调色)
    淡色强调波纹=修改颜色强度(44,强调色)
    淡色普通=0xfff5f5f5
    淡色普通波纹=0x22000000
    普通色=0xFFFFFFFF
    普通文字色=0xFF000000
    普通图片色=0xFF4E5264
    普通波纹=0x44000000
    工具栏阴影=0
    云极客颜色="red"
  end
  if activity.getSharedData("主题")=="4" then
    activity.setTheme(R.Theme_AppLua3)
    获取主题颜色()
    背景颜色=0xffffffff

    强调文字色=0xFFFFFFFF
    强调图片色=0xFFFFFFFF
    强调波纹=0x44FFFFFF
    淡色强调=修改颜色强度(22,强调色)
    淡色强调波纹=修改颜色强度(44,强调色)
    淡色普通=0xfff5f5f5
    淡色普通波纹=0x22000000
    普通色=0xFFFFFFFF
    普通文字色=0xFF000000
    普通图片色=0xFF4E5264
    普通波纹=0x44000000
    工具栏阴影=0
    云极客颜色="cyan"
  end
  if activity.getSharedData("主题")=="5" then
    activity.setTheme(R.Theme_AppLua4)
    获取主题颜色()
    背景颜色=0xFFFAFAFA

    强调文字色=0xFFFFFFFF
    强调图片色=0xFFFFFFFF
    强调波纹=0x22FFFFFF
    淡色强调=修改颜色强度(22,强调色)
    淡色强调波纹=修改颜色强度(44,强调色)
    淡色普通=0xFFF0F0F0
    淡色普通波纹=0x22000000
    普通色=0xFFD6D8D7
    普通文字色=0xFF000000
    普通图片色=0xFF4E5264
    普通波纹=0x44000000
    工具栏阴影=10
    云极客颜色="teal"
  end
  if activity.getSharedData("主题")=="6" then
    activity.setTheme(R.Theme_AppLua5)
    获取主题颜色()
    背景颜色=0xFFFAFAFA

    强调文字色=0xFFFFFFFF
    强调图片色=0xFFFFFFFF
    强调波纹=0x22FFFFFF
    淡色强调=修改颜色强度(22,强调色)
    淡色强调波纹=修改颜色强度(44,强调色)
    淡色普通=0xFFF0F0F0
    淡色普通波纹=0x22000000
    普通色=0xFFD6D8D7
    普通文字色=0xFF000000
    普通图片色=0xFF4E5264
    普通波纹=0x44000000
    工具栏阴影=10
    云极客颜色="teal"
  end

  if not(背景颜色) then--判断主题有没有错误
    activity.setSharedData("主题","1")--设置为默认主题
    print("已切换为默认主题")
    刷新主题()--刷新一边
  end



  activity.ActionBar.setElevation(工具栏阴影)--ActionBar阴影


  systemUIInfo="View.VISIBLE"
  activity.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS).setStatusBarColor(状态栏颜色);
  if tonumber(Build.VERSION.SDK) >= 23 then
    if not(是否暗色(string.upper(Integer.toHexString(状态栏颜色)))) then
      systemUIInfo=systemUIInfo.."|View.SYSTEM_UI_FLAG_LIGHT_STATUS_BAR"--暗色状态栏
      else
      
    end
  end
  if activity.getSharedData("导航栏使用暗色") == "true" then
    activity.getWindow().setNavigationBarColor(导航栏颜色)
   else
    activity.getWindow().setNavigationBarColor(背景颜色)
    if tonumber(Build.VERSION.SDK) >= 26 then
      if 是否暗色(string.upper(Integer.toHexString(背景颜色))) then
       else
        systemUIInfo=systemUIInfo.."|View.SYSTEM_UI_FLAG_LIGHT_NAVIGATION_BAR"--暗色导航栏
      end
    end
  end

  loadstring([[activity.getWindow().getDecorView().setSystemUiVisibility(]]..systemUIInfo..[[)]])()--设置SystemUI

  activity背景颜色(背景颜色)

end

if not(notLoadTheme==true) then
  刷新主题()
end


主题={}
主题.刷新=刷新主题
function 主题.强调(view)
  if type(view)=="android.widget.Button" then
    view.getBackground().setColorFilter(PorterDuffColorFilter(强调色,PorterDuff.Mode.SRC_ATOP))
    view.textColor=强调文字色
  end
end